<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "idp_provision".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "IdpProvision".
 *
 * Columns in table "idp_provision" available as properties of the model,
 * followed by relations of table "idp_provision" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $status
 * @property integer $partner_site_id
 * @property integer $organization_id
 * @property string $username
 * @property string $secret
 * @property string $update_summary_email
 * @property integer $update_summary_enabled
 * @property string $date_added
 * @property string $date_updated
 *
 * @property IdpEntityMatch[] $idpEntityMatches
 * @property IdpFeed[] $idpFeeds
 * @property Organization $organization
 * @property PartnerSite $partnerSite
 * @property IdpProvisionVerb[] $idpProvisionVerbs
 * @property IdpRequestLog[] $idpRequestLogs
 */
abstract class BaseIdpProvision extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'idp_provision';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'IdpProvision|IdpProvisions', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, username, secret, date_updated', 'required'),
            array('partner_site_id, organization_id, update_summary_enabled', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>45),
            array('status', 'length', 'max'=>1),
            array('username, update_summary_email', 'length', 'max'=>255),
            array('secret', 'length', 'max'=>60),
            array('date_added', 'safe'),
            array('status, partner_site_id, organization_id, update_summary_email, update_summary_enabled, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, status, partner_site_id, organization_id, username, secret, update_summary_email, update_summary_enabled, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'idpEntityMatches' => array(self::HAS_MANY, 'IdpEntityMatch', 'idp_provision_id'),
            'idpFeeds' => array(self::HAS_MANY, 'IdpFeed', 'idp_provision_id'),
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'idpProvisionVerbs' => array(self::HAS_MANY, 'IdpProvisionVerb', 'idp_provision_id'),
            'idpRequestLogs' => array(self::HAS_MANY, 'IdpRequestLog', 'idp_provision_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'status' => Yii::t('app', 'Status'),
            'partner_site_id' => null,
            'organization_id' => null,
            'username' => Yii::t('app', 'Username'),
            'secret' => Yii::t('app', 'Secret'),
            'update_summary_email' => Yii::t('app', 'Update Summary Email'),
            'update_summary_enabled' => Yii::t('app', 'Update Summary Enabled'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'idpEntityMatches' => null,
            'idpFeeds' => null,
            'organization' => null,
            'partnerSite' => null,
            'idpProvisionVerbs' => null,
            'idpRequestLogs' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('username', $this->username, true);
        $criteria->compare('secret', $this->secret, true);
        $criteria->compare('update_summary_email', $this->update_summary_email, true);
        $criteria->compare('update_summary_enabled', $this->update_summary_enabled);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
